package com.factory.web.service.impl.onsite;

import java.util.List;
import java.util.Map;
import java.util.function.Function;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.factory.base.entity.aggregates.PageBean;
import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.util.res.ResponseBeanBuilder;
import com.factory.web.entity.onsite.OnsiteItem;
import com.factory.web.entity.onsite.OnsiteItemRes;
import com.factory.web.entity.onsite.OnsiteItemReq;
import com.factory.web.entity.vo.res.web.ini.unAuditListRes;
import com.factory.web.mapper.ini.BentelerIniVersionMapper;
import com.factory.web.mapper.onsite.OnsiteItemMapper;
import com.factory.web.service.onsite.OnsiteItemService;

/**
 * 巡检项目设置
 *
 * @author wzy
 * @date 2021-07-06 12:10:10
 */
@Service("onsiteItemService")
@Transactional(rollbackFor = Exception.class)
public class OnsiteItemServiceImpl extends ServiceImpl<OnsiteItemMapper, OnsiteItem> implements OnsiteItemService {

	@Autowired
    private OnsiteItemMapper onsiteItemMapper;
	
	/**
     * 取得巡检项目列表
     * @param req
     * @return 巡检项目列表
     */
    public ResponseBean<PageBean<OnsiteItemRes>> getList(OnsiteItemReq req) {
    	Page<OnsiteItemRes> page = new Page<>(req.getPage(), req.getSize());
        Page<OnsiteItemRes> listResPage = onsiteItemMapper.getList(page, req);
        return ResponseBeanBuilder.ok(listResPage, Function.identity());
    }
}